
// multi.c    support multicore s30

#include "compile.h"

extern sym_entry symtab[];
extern int nsym;

// check if s is coreX
int iscore(char *s){
	string name;

	strncpy(name,s,4);		// get first four char
	name[4] = 0;			// terminate
	return strcmp(name,"core") == 0;
}

int getcoreNum(char *s){
	string num;

	strcpy(num,s+4);
	return atoi(num);
}

// count number of "coreX" in symbol table
int countcore(void){
	sym_entry *s;
	int i, cnt;

	cnt = 0;
	for( i=1; i<=nsym; i++ ) {
		s = &symtab[i];
		if( iscore(s->name))
			cnt++;
	}
	return cnt;
}

void gncoreHead(int k){
	int m;

	m = k*1000 + 3000;			// base stack segment
	printf("mov sp #%d\n", m);
	printf("mov fp #%d\n", m + 500);
}

